# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_catalog_lib.api_client import ApiClient


class DeploymentsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def check_deployment_name(self, name, **kwargs):  # noqa: E501
        """Check if a deployment exists.  # noqa: E501

        Returns OK if a deployment with the supplied name exists.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.check_deployment_name(name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Deployment name (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.check_deployment_name_with_http_info(name, **kwargs)  # noqa: E501
        else:
            (data) = self.check_deployment_name_with_http_info(name, **kwargs)  # noqa: E501
            return data

    def check_deployment_name_with_http_info(self, name, **kwargs):  # noqa: E501
        """Check if a deployment exists.  # noqa: E501

        Returns OK if a deployment with the supplied name exists.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.check_deployment_name_with_http_info(name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Deployment name (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method check_deployment_name" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'name' is set
        if ('name' not in params or
                params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `check_deployment_name`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'name' in params:
            path_params['name'] = params['name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/names/{name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def check_deployment_name_exists(self, name, **kwargs):  # noqa: E501
        """Check if a deployment exists.  # noqa: E501

        Returns OK if a deployment with the supplied name exists.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.check_deployment_name_exists(name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Deployment name (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.check_deployment_name_exists_with_http_info(name, **kwargs)  # noqa: E501
        else:
            (data) = self.check_deployment_name_exists_with_http_info(name, **kwargs)  # noqa: E501
            return data

    def check_deployment_name_exists_with_http_info(self, name, **kwargs):  # noqa: E501
        """Check if a deployment exists.  # noqa: E501

        Returns OK if a deployment with the supplied name exists.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.check_deployment_name_exists_with_http_info(name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Deployment name (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method check_deployment_name_exists" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'name' is set
        if ('name' not in params or
                params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `check_deployment_name_exists`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'name' in params:
            query_params.append(('name', params['name']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/names', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_deployment(self, deployment_id, **kwargs):  # noqa: E501
        """Delete a deployment. Effectively triggers a Delete Day2 operation  # noqa: E501

        Deletes the deployment with the supplied ID, cleans up the associated resources from the Cloud Provider.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_deployment(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param bool force_delete: Guarantees the deployment's deletion and all related resources from VMware Aria Automation. In some situations, this may leave provisioned infrastructure resources behind. Please ensure you remove them manually in such cases.
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_deployment_with_http_info(deployment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_deployment_with_http_info(deployment_id, **kwargs)  # noqa: E501
            return data

    def delete_deployment_with_http_info(self, deployment_id, **kwargs):  # noqa: E501
        """Delete a deployment. Effectively triggers a Delete Day2 operation  # noqa: E501

        Deletes the deployment with the supplied ID, cleans up the associated resources from the Cloud Provider.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_deployment_with_http_info(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param bool force_delete: Guarantees the deployment's deletion and all related resources from VMware Aria Automation. In some situations, this may leave provisioned infrastructure resources behind. Please ensure you remove them manually in such cases.
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deployment_id', 'force_delete']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_deployment" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `delete_deployment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501

        query_params = []
        if 'force_delete' in params:
            query_params.append(('forceDelete', params['force_delete']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20011',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_resource(self, deployment_id, resource_id, **kwargs):  # noqa: E501
        """Delete resource associated with a deployment. Effectively triggers a Delete Day2 operation.  # noqa: E501

        Deletes the resource with the specified ID and attempts to delete resource from the Cloud Provider.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_resource(deployment_id, resource_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param str resource_id: Resource ID (required)
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_resource_with_http_info(deployment_id, resource_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_resource_with_http_info(deployment_id, resource_id, **kwargs)  # noqa: E501
            return data

    def delete_resource_with_http_info(self, deployment_id, resource_id, **kwargs):  # noqa: E501
        """Delete resource associated with a deployment. Effectively triggers a Delete Day2 operation.  # noqa: E501

        Deletes the resource with the specified ID and attempts to delete resource from the Cloud Provider.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_resource_with_http_info(deployment_id, resource_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param str resource_id: Resource ID (required)
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deployment_id', 'resource_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_resource" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `delete_resource`")  # noqa: E501
        # verify the required parameter 'resource_id' is set
        if ('resource_id' not in params or
                params['resource_id'] is None):
            raise ValueError("Missing the required parameter `resource_id` when calling `delete_resource`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501
        if 'resource_id' in params:
            path_params['resourceId'] = params['resource_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}/resources/{resourceId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20011',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployment_by_id1(self, deployment_id, **kwargs):  # noqa: E501
        """Fetch a specific deployment.  # noqa: E501

        Returns the deployment with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_by_id1(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param bool expand_resources: The 'resources' field of the deployment will be retrieved.
        :param bool expand_last_request: Expands deployment last request.
        :param bool expand_project: The 'project' field of the deployment will be retrieved.
        :param list[str] expand: The expanded details of the requested comma separated objects. 'resources' option returns resources with all properties. Ex. blueprint, project
        :param bool deleted: Retrieves the deployment, includes soft-deleted deployments that have not yet been completely deleted.
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployment_by_id1_with_http_info(deployment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_deployment_by_id1_with_http_info(deployment_id, **kwargs)  # noqa: E501
            return data

    def get_deployment_by_id1_with_http_info(self, deployment_id, **kwargs):  # noqa: E501
        """Fetch a specific deployment.  # noqa: E501

        Returns the deployment with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_by_id1_with_http_info(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param bool expand_resources: The 'resources' field of the deployment will be retrieved.
        :param bool expand_last_request: Expands deployment last request.
        :param bool expand_project: The 'project' field of the deployment will be retrieved.
        :param list[str] expand: The expanded details of the requested comma separated objects. 'resources' option returns resources with all properties. Ex. blueprint, project
        :param bool deleted: Retrieves the deployment, includes soft-deleted deployments that have not yet been completely deleted.
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deployment_id', 'expand_resources', 'expand_last_request', 'expand_project', 'expand', 'deleted']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployment_by_id1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `get_deployment_by_id1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501

        query_params = []
        if 'expand_resources' in params:
            query_params.append(('expandResources', params['expand_resources']))  # noqa: E501
        if 'expand_last_request' in params:
            query_params.append(('expandLastRequest', params['expand_last_request']))  # noqa: E501
        if 'expand_project' in params:
            query_params.append(('expandProject', params['expand_project']))  # noqa: E501
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
            collection_formats['expand'] = 'multi'  # noqa: E501
        if 'deleted' in params:
            query_params.append(('deleted', params['deleted']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20015',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployment_expense_history_by_id(self, deployment_id, **kwargs):  # noqa: E501
        """Fetch a specific deployment's expense history.  # noqa: E501

        Returns the deployment expense history with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_expense_history_by_id(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param datetime _from: The timestamp from when history is requested. Should be of ISO_INSTANT format.
        :param datetime to: The timestamp until when history is requested. Should be of ISO_INSTANT format.
        :param str interval: The interval of the expense history. Should be one of daily, weekly or monthly.
        :return: InlineResponse20038
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployment_expense_history_by_id_with_http_info(deployment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_deployment_expense_history_by_id_with_http_info(deployment_id, **kwargs)  # noqa: E501
            return data

    def get_deployment_expense_history_by_id_with_http_info(self, deployment_id, **kwargs):  # noqa: E501
        """Fetch a specific deployment's expense history.  # noqa: E501

        Returns the deployment expense history with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_expense_history_by_id_with_http_info(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param datetime _from: The timestamp from when history is requested. Should be of ISO_INSTANT format.
        :param datetime to: The timestamp until when history is requested. Should be of ISO_INSTANT format.
        :param str interval: The interval of the expense history. Should be one of daily, weekly or monthly.
        :return: InlineResponse20038
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deployment_id', '_from', 'to', 'interval']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployment_expense_history_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `get_deployment_expense_history_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501

        query_params = []
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'interval' in params:
            query_params.append(('interval', params['interval']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}/expense-history', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20038',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployment_filter_by_id(self, filter_id, **kwargs):  # noqa: E501
        """Returns the Deployment filter with the supplied ID.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_filter_by_id(filter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str filter_id: Filter Id (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str search: Search string for filters
        :param list[str] projects: A comma-separated list. Results must be associated with one of these project IDs.
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :return: InlineResponse20028
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployment_filter_by_id_with_http_info(filter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_deployment_filter_by_id_with_http_info(filter_id, **kwargs)  # noqa: E501
            return data

    def get_deployment_filter_by_id_with_http_info(self, filter_id, **kwargs):  # noqa: E501
        """Returns the Deployment filter with the supplied ID.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_filter_by_id_with_http_info(filter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str filter_id: Filter Id (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str search: Search string for filters
        :param list[str] projects: A comma-separated list. Results must be associated with one of these project IDs.
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :return: InlineResponse20028
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['filter_id', 'page', 'size', 'sort', 'search', 'projects', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployment_filter_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'filter_id' is set
        if ('filter_id' not in params or
                params['filter_id'] is None):
            raise ValueError("Missing the required parameter `filter_id` when calling `get_deployment_filter_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'filter_id' in params:
            path_params['filterId'] = params['filter_id']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'search' in params:
            query_params.append(('search', params['search']))  # noqa: E501
        if 'projects' in params:
            query_params.append(('projects', params['projects']))  # noqa: E501
            collection_formats['projects'] = 'multi'  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/filters/{filterId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20028',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployment_filters(self, **kwargs):  # noqa: E501
        """Returns the Deployment filters in context of given user.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_filters(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20027
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployment_filters_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_deployment_filters_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_deployment_filters_with_http_info(self, **kwargs):  # noqa: E501
        """Returns the Deployment filters in context of given user.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_filters_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20027
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployment_filters" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/filters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20027',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployment_resources(self, deployment_id, **kwargs):  # noqa: E501
        """Fetch resources associated with a deployment.  # noqa: E501

        Returns a paginated list of resources corresponding to the deployment with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_resources(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] names: Results must have exactly these resource names.
        :param list[str] resource_types: A comma-separated list. Results must be associated with one of these resourceType Names.
        :param list[str] tags: A comma-separated list. Results must be associated with one of these tags
        :param list[str] expand: The expanded details of the requested comma separated objects. Ex. currentRequest
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :return: InlineResponse20036
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployment_resources_with_http_info(deployment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_deployment_resources_with_http_info(deployment_id, **kwargs)  # noqa: E501
            return data

    def get_deployment_resources_with_http_info(self, deployment_id, **kwargs):  # noqa: E501
        """Fetch resources associated with a deployment.  # noqa: E501

        Returns a paginated list of resources corresponding to the deployment with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployment_resources_with_http_info(deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] names: Results must have exactly these resource names.
        :param list[str] resource_types: A comma-separated list. Results must be associated with one of these resourceType Names.
        :param list[str] tags: A comma-separated list. Results must be associated with one of these tags
        :param list[str] expand: The expanded details of the requested comma separated objects. Ex. currentRequest
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :return: InlineResponse20036
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deployment_id', 'page', 'size', 'sort', 'names', 'resource_types', 'tags', 'expand', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployment_resources" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `get_deployment_resources`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'names' in params:
            query_params.append(('names', params['names']))  # noqa: E501
            collection_formats['names'] = 'multi'  # noqa: E501
        if 'resource_types' in params:
            query_params.append(('resourceTypes', params['resource_types']))  # noqa: E501
            collection_formats['resourceTypes'] = 'multi'  # noqa: E501
        if 'tags' in params:
            query_params.append(('tags', params['tags']))  # noqa: E501
            collection_formats['tags'] = 'multi'  # noqa: E501
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
            collection_formats['expand'] = 'multi'  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}/resources', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20036',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployments1(self, **kwargs):  # noqa: E501
        """Fetch all deployments.  # noqa: E501

        Returns a paginated list of deployments.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployments1(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] ids: A comma-separated list. Only deployments with these IDs will be included in the results.
        :param str search: Given string should either be part of a searchable field in a deployment or one of deployment's resources.
        :param str name: Results must have exactly this name.
        :param list[str] status: A comma-separated list. Results must be associated with one of these statuses.
        :param list[str] projects: A comma-separated list. Results must be associated with one of these project IDs.
        :param list[str] resource_types: A comma-separated list. Results must be associated with one of these resourceType Names.
        :param list[str] cloud_accounts: A comma-separated list. Results must be associated with one of these cloud accounts.
        :param list[str] cloud_types: A comma-separated list. Results must be associated with one of these endpoint Types
        :param list[str] requested_by: A comma-separated list. Results must be associated with one of these requesters
        :param list[str] owned_by: A comma-separated list. Results must be associated with one of these owners
        :param list[str] tags: A comma-separated list. Results must be associated with one of these tags
        :param CreatedAt created_at: Comma-separated start and end dates where start date or end date is optional (e.g. [2020-12-01T08:00:00.000Z,2020-12-11T23:59:00.000Z], [2020-11-03T08:00:00.000Z,], [,2020-11-08T08:00:00.000Z]
        :param ExpiresAt expires_at: Comma-separated start and end dates for the interval
        :param LastUpdatedAt last_updated_at: Comma-separated start and end dates where start date or end date is optional (e.g. [2020-12-01T08:00:00.000Z,2020-12-11T23:59:00.000Z], [2020-11-03T08:00:00.000Z,], [,2020-11-08T08:00:00.000Z]
        :param bool expand_resources: The 'resources' field of each resulting deployment will be retrieved.
        :param bool expand_last_request: Expands deployment last request.
        :param bool expand_project: The 'project' field of each resulting deployment will be retrieved.
        :param list[str] expand: The expanded details of the requested comma separated objects. 'resources' option returns resources with all properties. Ex. blueprint, project
        :param list[str] last_request_status: A comma-separated list of last request statuses. Allowed values are: ABORTED, APPROVAL_PENDING, APPROVAL_REJECTED, FAILED, INPROGRESS, PENDING and SUCCESSFUL. Results must be associated with one of these last request statuses.
        :param bool deleted: Retrieves only soft-deleted deployments that have not yet been completely deleted.
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :return: InlineResponse20034
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployments1_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_deployments1_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_deployments1_with_http_info(self, **kwargs):  # noqa: E501
        """Fetch all deployments.  # noqa: E501

        Returns a paginated list of deployments.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployments1_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] ids: A comma-separated list. Only deployments with these IDs will be included in the results.
        :param str search: Given string should either be part of a searchable field in a deployment or one of deployment's resources.
        :param str name: Results must have exactly this name.
        :param list[str] status: A comma-separated list. Results must be associated with one of these statuses.
        :param list[str] projects: A comma-separated list. Results must be associated with one of these project IDs.
        :param list[str] resource_types: A comma-separated list. Results must be associated with one of these resourceType Names.
        :param list[str] cloud_accounts: A comma-separated list. Results must be associated with one of these cloud accounts.
        :param list[str] cloud_types: A comma-separated list. Results must be associated with one of these endpoint Types
        :param list[str] requested_by: A comma-separated list. Results must be associated with one of these requesters
        :param list[str] owned_by: A comma-separated list. Results must be associated with one of these owners
        :param list[str] tags: A comma-separated list. Results must be associated with one of these tags
        :param CreatedAt created_at: Comma-separated start and end dates where start date or end date is optional (e.g. [2020-12-01T08:00:00.000Z,2020-12-11T23:59:00.000Z], [2020-11-03T08:00:00.000Z,], [,2020-11-08T08:00:00.000Z]
        :param ExpiresAt expires_at: Comma-separated start and end dates for the interval
        :param LastUpdatedAt last_updated_at: Comma-separated start and end dates where start date or end date is optional (e.g. [2020-12-01T08:00:00.000Z,2020-12-11T23:59:00.000Z], [2020-11-03T08:00:00.000Z,], [,2020-11-08T08:00:00.000Z]
        :param bool expand_resources: The 'resources' field of each resulting deployment will be retrieved.
        :param bool expand_last_request: Expands deployment last request.
        :param bool expand_project: The 'project' field of each resulting deployment will be retrieved.
        :param list[str] expand: The expanded details of the requested comma separated objects. 'resources' option returns resources with all properties. Ex. blueprint, project
        :param list[str] last_request_status: A comma-separated list of last request statuses. Allowed values are: ABORTED, APPROVAL_PENDING, APPROVAL_REJECTED, FAILED, INPROGRESS, PENDING and SUCCESSFUL. Results must be associated with one of these last request statuses.
        :param bool deleted: Retrieves only soft-deleted deployments that have not yet been completely deleted.
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :return: InlineResponse20034
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'size', 'sort', 'ids', 'search', 'name', 'status', 'projects', 'resource_types', 'cloud_accounts', 'cloud_types', 'requested_by', 'owned_by', 'tags', 'created_at', 'expires_at', 'last_updated_at', 'expand_resources', 'expand_last_request', 'expand_project', 'expand', 'last_request_status', 'deleted', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployments1" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'ids' in params:
            query_params.append(('ids', params['ids']))  # noqa: E501
            collection_formats['ids'] = 'multi'  # noqa: E501
        if 'search' in params:
            query_params.append(('search', params['search']))  # noqa: E501
        if 'name' in params:
            query_params.append(('name', params['name']))  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
            collection_formats['status'] = 'multi'  # noqa: E501
        if 'projects' in params:
            query_params.append(('projects', params['projects']))  # noqa: E501
            collection_formats['projects'] = 'multi'  # noqa: E501
        if 'resource_types' in params:
            query_params.append(('resourceTypes', params['resource_types']))  # noqa: E501
            collection_formats['resourceTypes'] = 'multi'  # noqa: E501
        if 'cloud_accounts' in params:
            query_params.append(('cloudAccounts', params['cloud_accounts']))  # noqa: E501
            collection_formats['cloudAccounts'] = 'multi'  # noqa: E501
        if 'cloud_types' in params:
            query_params.append(('cloudTypes', params['cloud_types']))  # noqa: E501
            collection_formats['cloudTypes'] = 'multi'  # noqa: E501
        if 'requested_by' in params:
            query_params.append(('requestedBy', params['requested_by']))  # noqa: E501
            collection_formats['requestedBy'] = 'multi'  # noqa: E501
        if 'owned_by' in params:
            query_params.append(('ownedBy', params['owned_by']))  # noqa: E501
            collection_formats['ownedBy'] = 'multi'  # noqa: E501
        if 'tags' in params:
            query_params.append(('tags', params['tags']))  # noqa: E501
            collection_formats['tags'] = 'multi'  # noqa: E501
        if 'created_at' in params:
            query_params.append(('createdAt', params['created_at']))  # noqa: E501
        if 'expires_at' in params:
            query_params.append(('expiresAt', params['expires_at']))  # noqa: E501
        if 'last_updated_at' in params:
            query_params.append(('lastUpdatedAt', params['last_updated_at']))  # noqa: E501
        if 'expand_resources' in params:
            query_params.append(('expandResources', params['expand_resources']))  # noqa: E501
        if 'expand_last_request' in params:
            query_params.append(('expandLastRequest', params['expand_last_request']))  # noqa: E501
        if 'expand_project' in params:
            query_params.append(('expandProject', params['expand_project']))  # noqa: E501
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
            collection_formats['expand'] = 'multi'  # noqa: E501
        if 'last_request_status' in params:
            query_params.append(('lastRequestStatus', params['last_request_status']))  # noqa: E501
            collection_formats['lastRequestStatus'] = 'multi'  # noqa: E501
        if 'deleted' in params:
            query_params.append(('deleted', params['deleted']))  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20034',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_deployments_for_project(self, project_id, **kwargs):  # noqa: E501
        """Returns a count of deployments using the project.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployments_for_project(project_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str project_id: Project ID (required)
        :return: InlineResponse20033
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_deployments_for_project_with_http_info(project_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_deployments_for_project_with_http_info(project_id, **kwargs)  # noqa: E501
            return data

    def get_deployments_for_project_with_http_info(self, project_id, **kwargs):  # noqa: E501
        """Returns a count of deployments using the project.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_deployments_for_project_with_http_info(project_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str project_id: Project ID (required)
        :return: InlineResponse20033
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_deployments_for_project" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_id' is set
        if ('project_id' not in params or
                params['project_id'] is None):
            raise ValueError("Missing the required parameter `project_id` when calling `get_deployments_for_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_id' in params:
            path_params['projectId'] = params['project_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/projects/{projectId}/deployment-count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20033',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_resource_by_id1(self, deployment_id, resource_id, **kwargs):  # noqa: E501
        """Fetch resource associated with a deployment.  # noqa: E501

        Returns the resource with the specified ID that is correlated with the supplied deployment.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_resource_by_id1(deployment_id, resource_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param str resource_id: Resource ID (required)
        :param list[str] expand: The expanded details of the requested comma separated objects. Ex. currentRequest
        :return: InlineResponse20037
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_resource_by_id1_with_http_info(deployment_id, resource_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_resource_by_id1_with_http_info(deployment_id, resource_id, **kwargs)  # noqa: E501
            return data

    def get_resource_by_id1_with_http_info(self, deployment_id, resource_id, **kwargs):  # noqa: E501
        """Fetch resource associated with a deployment.  # noqa: E501

        Returns the resource with the specified ID that is correlated with the supplied deployment.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_resource_by_id1_with_http_info(deployment_id, resource_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str deployment_id: Deployment ID (required)
        :param str resource_id: Resource ID (required)
        :param list[str] expand: The expanded details of the requested comma separated objects. Ex. currentRequest
        :return: InlineResponse20037
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['deployment_id', 'resource_id', 'expand']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_resource_by_id1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `get_resource_by_id1`")  # noqa: E501
        # verify the required parameter 'resource_id' is set
        if ('resource_id' not in params or
                params['resource_id'] is None):
            raise ValueError("Missing the required parameter `resource_id` when calling `get_resource_by_id1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501
        if 'resource_id' in params:
            path_params['resourceId'] = params['resource_id']  # noqa: E501

        query_params = []
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
            collection_formats['expand'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}/resources/{resourceId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20037',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_deployment(self, body, deployment_id, **kwargs):  # noqa: E501
        """Update deployment.  # noqa: E501

        Updates the deployment with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_deployment(body, deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeploymentsDeploymentIdBody body: (required)
        :param str deployment_id: Deployment ID (required)
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_deployment_with_http_info(body, deployment_id, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_deployment_with_http_info(body, deployment_id, **kwargs)  # noqa: E501
            return data

    def patch_deployment_with_http_info(self, body, deployment_id, **kwargs):  # noqa: E501
        """Update deployment.  # noqa: E501

        Updates the deployment with the supplied ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_deployment_with_http_info(body, deployment_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeploymentsDeploymentIdBody body: (required)
        :param str deployment_id: Deployment ID (required)
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'deployment_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_deployment" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_deployment`")  # noqa: E501
        # verify the required parameter 'deployment_id' is set
        if ('deployment_id' not in params or
                params['deployment_id'] is None):
            raise ValueError("Missing the required parameter `deployment_id` when calling `patch_deployment`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'deployment_id' in params:
            path_params['deploymentId'] = params['deployment_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/deployment/api/deployments/{deploymentId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20015',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
